CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Friends
csl::RingBuffer Class Reference

RingBuffer is the storage + a default reader. More...

`#include <RingBuffer.h>`

Inheritance diagram for csl::RingBuffer:

List of all members.

## Public Member Functions
| RingBuffer ()
| Constructors.
| RingBuffer (unsigned int nmChannels, unsigned int nmFrames)
| RingBuffer (UnitGenerator &input, unsigned int nmChannels, unsigned int nmFrames)
unsigned | seekTo (int position) throw (CException)
void | setLoopStart (unsigned frame)
| These loop setters allow for variable buffer lengths by varying the points where the buffer writes.
void | setLoopEnd (unsigned frame)
| Calls the setLoopStart of it's tap.
void | nextBuffer (Buffer &outputBuffer) throw (CException)
| Calls the setLoopEnd of it's tap.
void | writeBuffer (Buffer &inputBuffer) throw (CException)
| Write a buffer of data into the ring buffer.
void | sumIntoBuffer (Buffer &inputBuffer) throw (CException)
| Do an adding write of data into the ring buffer.
void | destructiveNextBuffer (Buffer &outputBuffer) throw (CException)
| Read a buffer zeroing as you go.
void | writeBuffer (Buffer &inputBuffer, unsigned bufNum) throw (CException)
| write to the receiver
void | sumIntoBuffer (Buffer &inputBuffer, unsigned bufNum) throw (CException)
virtual bool | isActive ()
| am I active?
void | setInput (UnitGenerator &inp)
| set the receiver's input generator
void | setInline ()
| set the Effect to be inline
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
virtual void | dump ()
| pretty-print the receiver
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)
Port * | getPort (CSL_MAP_KEY name)
void | setScale (UnitGenerator &scale)
| set the receiver's scale member to a UGen or a float
void | setScale (float scale)
void | setOffset (UnitGenerator &offset)
| set the receiver's offset member to a UGen or a float
void | setOffset (float offset)
virtual void | trigger ()
| trigger passed on here
void | isScaled ()
| answer whether scale = 1 & offset = 0

## Public Attributes
unsigned | mCurrentWriteFrame
| state – users can manipulate my internal tap and buffer
Buffer | mBuffer
RingBufferTap | mTap
| internal tap so a RingBuffer can also be a a UnitGenerator
bool | isInline
| whether to use input or buffer as source

## Protected Member Functions
void | pullInput (Buffer &outputBuffer) throw (CException)
void | pullInput (unsigned numFrames) throw (CException)
| trigger passed on here
void | pullInput (Port *thePort, unsigned numFrames) throw (CException)
| method to read the control values (in case they're dynamic). this sends nextBuffer() to the input.
void | pullInput (Port *thePort, Buffer &theBuffer) throw (CException)
virtual void | trigger ()
| trigger passed on here get the input port
Port * | inPort ()
virtual void | dump ()
| pretty-print the receiver's input/controls map
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer
void | addInput (CSL_MAP_KEY name, UnitGenerator &ugen)
| Plug in a unit generator to the named input slot.
void | addInput (CSL_MAP_KEY name, float value)
| Plug in a float to the named input slot.

## Protected Attributes
unsigned | mTempCurrentWriteFrame
| Used in next buffer to save state between calls in the same block.
SampleBuffer | mInputPtr
| A pointer to my input's data. method to read the input value.
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number
PortMap | mInputs
| the map of my inputs or controls (used by the mix-in classes)

## Friends
class | RingBufferTap
| Allow the RingBufferTap to access private members of this class.

## Detailed Description

RingBuffer is the storage + a default reader.

Definition at line 56 of file RingBuffer.h.

## Constructor & Destructor Documentation

RingBuffer::RingBuffer | ( |  | ) |

Constructors.

Definition at line 163 of file RingBuffer.cpp.

References mTap, and csl::RingBufferTap::setBuffer().

RingBuffer::RingBuffer | ( | unsigned int | nmChannels,
|  | unsigned int | nmFrames
| ) |  |

Definition at line 169 of file RingBuffer.cpp.

References csl::Buffer::allocateBuffers(), mBuffer, mTap, and csl::RingBufferTap::setBuffer().

RingBuffer::RingBuffer | ( | UnitGenerator & | input,
|  | unsigned int | nmChannels,
|  | unsigned int | nmFrames
| ) |  |

Definition at line 177 of file RingBuffer.cpp.

References csl::Buffer::allocateBuffers(), mBuffer, mTap, and csl::RingBufferTap::setBuffer().

## Member Function Documentation

unsigned RingBuffer::seekTo | ( | int | position | ) | throw (CException)

Definition at line 213 of file RingBuffer.cpp.

void csl::RingBuffer::setLoopStart | ( | unsigned | frame | ) |
| inline

These loop setters allow for variable buffer lengths by varying the points where the buffer writes.

Definition at line 73 of file RingBuffer.h.

References mTap, and csl::RingBufferTap::setLoopStart().

void csl::RingBuffer::setLoopEnd | ( | unsigned | frame | ) |
| inline

Calls the setLoopStart of it's tap.

Definition at line 74 of file RingBuffer.h.

References mTap, and csl::RingBufferTap::setLoopEnd().

void RingBuffer::nextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)
| virtual

Calls the setLoopEnd of it's tap.

Various flavours of next buffer. Also the nextBuffer(Buffer &) has to be implemented to be able to hold state of the currentWriteFrame. Otherwise every time it's called by the super nextBuffer the currentWriteFrame would be incremented more and more, leading to erroneous results. Read a buffer from the ring buffer

Reimplemented from csl::UnitGenerator.

Definition at line 187 of file RingBuffer.cpp.

References CSL_INPUT, and csl::Effect::pullInput().

void RingBuffer::writeBuffer | ( | Buffer & | inputBuffer | ) | throw (CException)
| virtual

Write a buffer of data into the ring buffer.

Reimplemented from csl::Writeable.

Definition at line 199 of file RingBuffer.cpp.

References csl::Writeable::writeBuffer().

Referenced by csl::CslRtpSession::OnRTPPacket().

void RingBuffer::sumIntoBuffer | ( | Buffer & | inputBuffer | ) | throw (CException)

Do an adding write of data into the ring buffer.

Definition at line 205 of file RingBuffer.cpp.

void RingBuffer::destructiveNextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)

Read a buffer zeroing as you go.

Definition at line 195 of file RingBuffer.cpp.

void RingBuffer::writeBuffer | ( | Buffer & | inputBuffer,
|  | unsigned | bufNum
| ) |  | throw (CException)
| virtual

write to the receiver

Reimplemented from csl::Writeable.

Definition at line 225 of file RingBuffer.cpp.

References memcpy().

void RingBuffer::sumIntoBuffer | ( | Buffer & | inputBuffer,
|  | unsigned | bufNum
| ) |  | throw (CException)

Definition at line 259 of file RingBuffer.cpp.

bool Effect::isActive | ( |  | ) |
| virtual inherited

am I active?

Reimplemented from csl::UnitGenerator.

Reimplemented in csl::Joiner, and csl::Stereoverb.

Definition at line 951 of file CSL_Core.cpp.

References CSL_INPUT, csl::Port::isActive(), and csl::Controllable::mInputs.

Referenced by csl::Stereoverb::isActive().

void Effect::setInput | ( | UnitGenerator & | inp | ) |
| inherited

set the receiver's input generator

Definition at line 958 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_INPUT, csl::Effect::isInline, and csl::logMsg().

void csl::Effect::setInline | ( |  | ) |
| inline inherited

set the Effect to be inline

Definition at line 446 of file CSL_Core.h.

References csl::Effect::isInline.

void Effect::pullInput | ( | Buffer & | outputBuffer | ) | throw (CException)
| protected inherited

Definition at line 968 of file CSL_Core.cpp.

References CSL_INPUT, csl::logMsg(), and csl::Controllable::pullInput().

Referenced by csl::InOut::nextBuffer(), nextBuffer(), csl::Panner::nextBuffer(), csl::FIR::nextBuffer(), csl::Filter::nextBuffer(), csl::DynamicVariable::nextBuffer(), csl::NtoMPanner::nextBuffer(), csl::StereoWidth::nextBuffer(), and SAFliter::nextBuffer().

void Effect::pullInput | ( | unsigned | numFrames | ) | throw (CException)
| protected inherited

trigger passed on here

Definition at line 983 of file CSL_Core.cpp.

References csl::Buffer::buffer(), CSL_INPUT, csl::logMsg(), csl::Port::mBuffer, and csl::Controllable::pullInput().

void Controllable::pullInput | ( | Port * | thePort,
|  | unsigned | numFrames
| ) |  | throw (CException)
| protected inherited

method to read the control values (in case they're dynamic). this sends nextBuffer() to the input.

Definition at line 695 of file CSL_Core.cpp.

References csl::kSamples, csl::logMsg(), csl::Buffer::mIsPopulated, csl::Buffer::mNumFrames, csl::Buffer::mType, csl::UnitGenerator::nextBuffer(), and csl::Buffer::zeroBuffers().

Referenced by csl::Panner::nextBuffer(), csl::NtoMPanner::nextBuffer(), and csl::Effect::pullInput().

void Controllable::pullInput | ( | Port * | thePort,
|  | Buffer & | theBuffer
| ) |  | throw (CException)
| protected inherited

Definition at line 727 of file CSL_Core.cpp.

References csl::UnitGenerator::nextBuffer().

void Effect::trigger | ( | void |  | ) |
| protected virtual inherited

trigger passed on here get the input port

Reimplemented from csl::UnitGenerator.

Reimplemented in csl::Joiner.

Definition at line 994 of file CSL_Core.cpp.

References CSL_INPUT, and csl::Controllable::mInputs.

Port* csl::Effect::inPort | ( |  | ) |
| inline protected inherited

Definition at line 455 of file CSL_Core.h.

References CSL_INPUT, and csl::Controllable::mInputs.

Referenced by csl::BinaryOp::dump(), and csl::BinaryOp::inputIsFixed().

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by csl::AmbisonicPanner::AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), csl::AmbisonicUnitGenerator::initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

void UnitGenerator::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented in csl::Joiner, csl::Splitter, csl::FanOut, SAFliter, csl::RandEnvelope, csl::Moog, csl::AmbisonicDecoder, csl::Impulse, csl::Square, csl::AmbisonicEncoder, csl::Sawtooth, csl::FSine, csl::MulOp, csl::Envelope, csl::Sine, csl::DynamicVariable, csl::Filter, csl::AmbisonicRotator, csl::CompOrCacheOscillator, csl::BufferStream, csl::AddOp, csl::FIR, csl::WavetableOscillator, csl::PinkNoise, csl::VBAP, csl::RtpReceiver, csl::SineAsScaled, csl::SpatialSource, csl::LineSegment, csl::StaticVariable, csl::AmbisonicMixer, csl::WhiteNoise, csl::SineAsPhased, csl::SpatialPanner, csl::Window, csl::RingBufferTap, csl::BinaryOp, csl::Freeverb, csl::KarplusString, csl::RtpSender, csl::Clipper, csl::Lorenz, csl::SimpleSine, csl::DistanceSimulator, and csl::WaveShaper.

Definition at line 605 of file CSL_Core.cpp.

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

void UnitGenerator::dump | ( | void |  | ) |
| virtual inherited

pretty-print the receiver

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::VBAP, csl::SineAsScaled, csl::LineSegment, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::Window, csl::KarplusString, csl::Oscillator, csl::AmbisonicPanner, csl::BinaryOp, csl::Lorenz, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 543 of file CSL_Core.cpp.

References csl::logMsg(), and csl::UnitGenerator::mOutputs.

Referenced by csl::Port::dump(), dumpTest(), and testSimpleSines().

void Controllable::dump | ( | void |  | ) |
| protected virtual inherited

pretty-print the receiver's input/controls map

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::SineAsScaled, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::KarplusString, csl::Oscillator, csl::BinaryOp, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 774 of file CSL_Core.cpp.

References CSL_FREQUENCY, CSL_INPUT, CSL_OFFSET, CSL_SCALE, csl::logMsg(), and csl::Controllable::mInputs.

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

Port * Controllable::getPort | ( | CSL_MAP_KEY | name | ) |
| inherited

Definition at line 768 of file CSL_Core.cpp.

References csl::Controllable::mInputs.

Referenced by csl::FrequencyAmount::getFrequency(), and csl::VSTIO::getParameter().

void Controllable::addInput | ( | CSL_MAP_KEY | name,
|  | UnitGenerator & | ugen
| ) |  |
| protected inherited

Plug in a unit generator to the named input slot.

Definition at line 742 of file CSL_Core.cpp.

References csl::UnitGenerator::addOutput(), csl::logMsg(), and csl::Controllable::mInputs.

Referenced by csl::BinaryOp::BinaryOp(), csl::DistanceSimulator::DistanceSimulator(), csl::Effect::Effect(), csl::InOut::InOut(), csl::NtoMPanner::NtoMPanner(), csl::Panner::Panner(), csl::Phased::Phased(), csl::Scalable::Scalable(), csl::FrequencyAmount::setAmount(), csl::FrequencyAmount::setFrequency(), csl::Phased::setFrequency(), csl::Effect::setInput(), csl::Scalable::setOffset(), csl::Panner::setPosition(), csl::Abst_SoundFile::setRate(), csl::Scalable::setScale(), csl::NtoMPanner::setX(), csl::NtoMPanner::setY(), and csl::SpatialSource::SpatialSource().

void Controllable::addInput | ( | CSL_MAP_KEY | name,
|  | float | value
| ) |  |
| protected inherited

Plug in a float to the named input slot.

Definition at line 754 of file CSL_Core.cpp.

References csl::logMsg(), csl::Controllable::mInputs, and csl::Port::mValue.

void Scalable::setScale | ( | UnitGenerator & | scale | ) |
| inherited

set the receiver's scale member to a UGen or a float

Definition at line 887 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_SCALE, and csl::logMsg().

Referenced by createRandFreqEnvPatch(), csl::FancyFMInstrument::FancyFMInstrument(), csl::AdditiveInstrument::init(), csl::SndFileInstrument::initialize(), main(), csl::FMInstrument::parseArgs(), csl::SndFileInstrument::playNote(), csl::SndFileInstrument::playOSC(), csl::AdditiveInstrument::setParameter(), csl::SndFileInstrument::setParameter(), csl::FancyFMInstrument::setParameter(), sosNote(), test_SHARC(), test_SHARC2(), testADSR_FM(), testARSin2(), testComplexEnvelope(), testEnvScale(), testFancy_FM(), testFanMix1(), testFanMix2(), testMultiTap(), testRandFreqEnv(), testReverb(), testSplitJoin1(), testSplitJoin2(), testStereoverb(), testString(), testStringChorus(), testSumOfSines1F(), testSumOfSinesCached(), testSumOfSinesNonCached(), testSumOfSinesSteps(), and testWaveShaper().

void Scalable::setScale | ( | float | scale | ) |
| inherited

Definition at line 894 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_SCALE, and csl::logMsg().

void Scalable::setOffset | ( | UnitGenerator & | offset | ) |
| inherited

set the receiver's offset member to a UGen or a float

Definition at line 901 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_OFFSET, and csl::logMsg().

void Scalable::setOffset | ( | float | offset | ) |
| inherited

Reimplemented in csl::RandEnvelope.

Definition at line 908 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_OFFSET, and csl::logMsg().

void Scalable::trigger | ( | void |  | ) |
| virtual inherited

trigger passed on here

Reimplemented in csl::RandEnvelope, csl::Abst_SoundFile, csl::Envelope, and csl::KarplusString.

Definition at line 917 of file CSL_Core.cpp.

References CSL_OFFSET, CSL_SCALE, and csl::Controllable::mInputs.

void csl::Scalable::isScaled | ( |  | ) |
| inherited

answer whether scale = 1 & offset = 0

## Friends And Related Function Documentation

friend class RingBufferTap
| friend

Allow the RingBufferTap to access private members of this class.

Definition at line 59 of file RingBuffer.h.

## Member Data Documentation

unsigned csl::RingBuffer::mCurrentWriteFrame

state – users can manipulate my internal tap and buffer

Definition at line 65 of file RingBuffer.h.

Referenced by csl::DelayLine::delayLength(), and csl::RingBufferTap::setOffset().

Buffer csl::RingBuffer::mBuffer

Definition at line 66 of file RingBuffer.h.

Referenced by csl::DelayLine::DelayLine(), csl::RingBufferTap::duration(), RingBuffer(), and csl::RingBufferTap::setOffset().

RingBufferTap csl::RingBuffer::mTap

internal tap so a RingBuffer can also be a a UnitGenerator

Definition at line 67 of file RingBuffer.h.

Referenced by csl::DelayLine::delayLength(), RingBuffer(), csl::DelayLine::setDelayLength(), csl::DelayLine::setDelayTime(), setLoopEnd(), setLoopStart(), and testMultiTap().

unsigned csl::RingBuffer::mTempCurrentWriteFrame
| protected

Used in next buffer to save state between calls in the same block.

Definition at line 87 of file RingBuffer.h.

bool csl::Effect::isInline
| inherited

whether to use input or buffer as source

Definition at line 445 of file CSL_Core.h.

Referenced by csl::Effect::Effect(), csl::Effect::setInline(), and csl::Effect::setInput().

SampleBuffer csl::Effect::mInputPtr
| protected inherited

A pointer to my input's data. method to read the input value.

Definition at line 449 of file CSL_Core.h.

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), csl::SndFileInstrument::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicUnitGenerator::initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

PortMap csl::Controllable::mInputs
| protected inherited

the map of my inputs or controls (used by the mix-in classes)

Definition at line 353 of file CSL_Core.h.

Referenced by csl::Controllable::addInput(), csl::BinaryOp::dump(), csl::Controllable::dump(), csl::Controllable::getPort(), csl::Effect::inPort(), csl::Effect::isActive(), csl::Joiner::isActive(), csl::SquareBL::nextWaveInto(), csl::BinaryOp::operandIsFixed(), csl::Phased::Phased(), csl::DistanceSimulator::positionChanged(), csl::Scalable::Scalable(), csl::BinaryOp::setOperand(), csl::Abst_SoundFile::setRate(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Allpass::setupCoeffs(), csl::Moog::setupCoeffs(), csl::Scalable::trigger(), csl::Effect::trigger(), csl::Joiner::trigger(), and csl::Controllable::~Controllable().

The documentation for this class was generated from the following files:

- CSL/Utilities/RingBuffer.h
- CSL/Utilities/RingBuffer.cpp